// TempHumMeterRemoteConsole.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <time.h>
#include <windows.h>
#include <stdlib.h>
#include <vector>
#include <string>
#include "TempHumMeterRemoteConsole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CWinApp theApp;

using namespace std;

/*******************
******Globals*******
*******************/
HANDLE hPort = NULL;

BOOL OpenComm(void)
{
	BOOL bRetCode = FALSE;
	DCB dcbStr;
	TCHAR tcComPortAddr[MAX128];
	TCHAR tcValue[MAX128];
	char cValue[MAX128];
	
	DWORD dwLen = sizeof(tcValue);
	/*****************************
	***Trying to get COM port #***
	******************************/

	if (ERROR_SUCCESS == RegGetValue(HKEY_LOCAL_MACHINE, TEXT("HARDWARE\\DEVICEMAP\\SERIALCOMM"), TEXT("\\Device\\VCP0"), RRF_RT_REG_SZ, NULL, tcValue, &dwLen))
	{
		wcstombs_s(NULL, cValue, MAX128, tcValue, MAX128);
		printf("USB2UART port found. Attempting %s\n", cValue);
		tcComPortAddr[0] = 0;
		tcComPortAddr[1] = 0;
		wcscat_s(tcComPortAddr, MAX128, L"\\\\.\\");
		wcscat_s(tcComPortAddr, MAX128, tcValue);
		hPort = CreateFile((LPCWSTR)tcComPortAddr, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	}
	else
	{
		/************************
		****Exiting..........****
		*************************/
		bRetCode = 1;
	}

	if (!GetCommState(hPort, &dcbStr))
	{
		bRetCode = 1;
	}
	dcbStr.BaudRate = CBR_19200;
	dcbStr.ByteSize = EIGHTBIT;
	dcbStr.Parity = NOPARITY;
	dcbStr.StopBits = ONESTOPBIT;
	if (!SetCommState(hPort, &dcbStr))
	{
		bRetCode = 1;
	}
	return (bRetCode);
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
	
	DWORD dwBytesRead = 0;
	unsigned char ucVdata[MAX_BUF];
	
	HMODULE hModule = ::GetModuleHandle(NULL);
	time_t ttRawtime = 0;
	time_t ttCurtime = 0;
	unsigned char ucState = 0;

	double df_T = 0.0;
	double df_P = 0.0;
	double df_H = 0.0;
	int t_fine_mst;

	const unsigned char ucPattern[] = { 'a', 'l', 'x', 'l', 'a', 'b', 's', 'O' };
	unsigned int uiMatch = 0;
	unsigned int uiRCCntr = 0;
	unsigned char ucRCPat[ONELOAD];
	time_t ttTime = time(NULL);
	unsigned char ucCRC = 0;
	DWORD dwError;
	char cBuf[MAX_BUF];
	

	FILE *fpFile = NULL;

	if (hModule != NULL)
	{
		/**************************************************
		***initialize MFC and print and error on failure***
		**************************************************/
		if (!AfxWinInit(hModule, NULL, ::GetCommandLine(), 0))
		{
			_tprintf(_T("Fatal Error: MFC initialization failed\n"));
			nRetCode = 1;
		}
		else
		{
			
			if (!OpenComm())
			{
				uiMatch = 0;
				while (true)
				{
					::ReadFile(hPort, ucVdata, 1, &dwBytesRead, NULL);
					dwError = GetLastError();
					if (dwError && ERR_ALREADY != dwError)
					{
						printf("Error(1): %d\nWill wait here till port is possible to re-open....\n", dwError);
						CloseHandle(hPort);
						while (OpenComm());
						printf("Succes!\n");
					}
					if (dwBytesRead)
					{
						if (ucVdata[0] == ucPattern[uiMatch])
						{
							uiMatch++;
							if (sizeof(ucPattern) == uiMatch)
							{
								ttTime = time(NULL);
								ctime_s((char*)ucVdata, sizeof(ucVdata), &ttTime);

								for (uiRCCntr = 0; uiRCCntr < sizeof(ucVdata); uiRCCntr++)
								{
									if (CARRRET == ucVdata[uiRCCntr])
									{
										ucVdata[uiRCCntr] = 0;
									}
								}

								printf("\n[%s]Pattern found.\n", ucVdata);
								uiMatch = 0;
								ucCRC = 0;
								/**********************
								***Initialize buffer***
								**********************/
								for (uiRCCntr = 0; uiRCCntr < ONELOAD; uiRCCntr++)
								{
									ucRCPat[uiRCCntr] = 0;
								}
								ucState = 0;
								/************************************
								**77 + 8hex bytes from address 0x88**
								************************************/
								for (uiRCCntr = STARTADDR; uiRCCntr < ONELOAD; uiRCCntr++)
								{
									dwBytesRead = 0;
									time(&ttRawtime);
									while (!dwBytesRead)
									{
										::ReadFile(hPort, ucVdata, 1, &dwBytesRead, NULL);
										dwError = GetLastError();
										if (dwError && ERR_ALREADY != dwError)
										{
											printf("Error(2): %d\nWill wait here till port is possible to re-open....\n", dwError);
											CloseHandle(hPort);
											while (OpenComm());
											printf("Succes!\n");
										}

										time(&ttCurtime);
										if (ttCurtime - ttRawtime > RDTIMEOUT)
										{
											printf("Timeout, exiting...\n");
											uiRCCntr = ONELOAD;
											dwBytesRead = EXITONE;
											ucState = ERRRECG;
										}
									}
									ucRCPat[uiRCCntr] = ucVdata[0];
									if (ONELOAD - 1 != uiRCCntr)
									{
										ucCRC += ucVdata[0];
									}
								}
								/******************
								***Calculations****
								******************/

								if (ucCRC != ucRCPat[CRCBYTE])
								{
									printf("CRC Error...\n");
									ucState = ERRRECG;
								}

								if (!ucState)
								{

									{
										//Measure T in Celsius
										int t_fine, adc_T;
										int var1, var2, T;
										short dig_T1, dig_T2, dig_T3;
										unsigned short us_Comp;
										short s_CompX;

										us_Comp = (unsigned short)ucRCPat[0x88] + ((unsigned short)ucRCPat[0x89] << 8);
										dig_T1 = (unsigned short)us_Comp;
										s_CompX = (short)ucRCPat[0x8a] + ((short)ucRCPat[0x8b] << 8);
										dig_T2 = s_CompX;
										s_CompX = (short)ucRCPat[0x8c] + ((short)ucRCPat[0x8d] << 8);
										dig_T3 = s_CompX;

										adc_T = (int)ucRCPat[0xff + 4] + ((int)ucRCPat[0xff + 3] << 8);
										adc_T = adc_T << 4;
										adc_T = adc_T | ((int)ucRCPat[0xff + 5] >> 4);
										var1 = ((((adc_T >> 3) - ((int)dig_T1 << 1)))*((int)dig_T2)) >> 11;
										var2 = (((((adc_T >> 4) - ((int)dig_T1))*((adc_T >> 4) - ((int)dig_T1))) >> 12)*((int)dig_T3)) >> 14;
										t_fine = var1 + var2;
										t_fine_mst = t_fine;
										T = (t_fine * 5 + 128) >> 8;
										df_T = 0.01 * (double)T;
									}

									{
										//pressure
										__int64 var1, var2, p;
										int adc_P;
										unsigned short dig_P1;
										short dig_P2, dig_P3, dig_P4, dig_P5, dig_P6, dig_P7, dig_P8, dig_P9;
										short s_CompX;
										unsigned short us_Comp;
			
										us_Comp = (unsigned short)ucRCPat[0x8e] + ((unsigned short)ucRCPat[0x8f] << 8);
										dig_P1 = (unsigned short)us_Comp;
										s_CompX = (short)ucRCPat[0x90] + ((short)ucRCPat[0x91] << 8);
										dig_P2 = s_CompX;
										s_CompX = (short)ucRCPat[0x92] + ((short)ucRCPat[0x93] << 8);
										dig_P3 = s_CompX;
										s_CompX = (short)ucRCPat[0x94] + ((short)ucRCPat[0x95] << 8);
										dig_P4 = s_CompX;
										s_CompX = (short)ucRCPat[0x96] + ((short)ucRCPat[0x97] << 8);
										dig_P5 = s_CompX;
										s_CompX = (short)ucRCPat[0x98] + ((short)ucRCPat[0x99] << 8);
										dig_P6 = s_CompX;
										s_CompX = (short)ucRCPat[0x9a] + ((short)ucRCPat[0x9b] << 8);
										dig_P7 = s_CompX;
										s_CompX = (short)ucRCPat[0x9c] + ((short)ucRCPat[0x9d] << 8);
										dig_P8 = s_CompX;
										s_CompX = (short)ucRCPat[0x9e] + ((short)ucRCPat[0x9f] << 8);
										dig_P9 = s_CompX;
		
										adc_P = (int)ucRCPat[0xff + 1] + ((int)ucRCPat[0xff] << 8);
										adc_P = adc_P << 4;
										adc_P = adc_P | ((int)ucRCPat[0xff + 2] >> 4);

										var1 = ((__int64)t_fine_mst) - 128000;
										var2 = var1 * var1 * (__int64)dig_P6;
										var2 = var2 + ((var1*(__int64)dig_P5) << 17);
										var2 = var2 + (((__int64)dig_P4) << 35);
										var1 = ((var1 * var1 * (__int64)dig_P3) >> 8) + ((var1 * (__int64)dig_P2) << 12);
										var1 = (((((__int64)1) << 47) + var1))*((__int64)dig_P1) >> 33;
										if (var1 == 0)
										{
											var1 = 1;
											//avoid exception caused by division by zero
										}
										p = 1048576 - adc_P;
										p = (((p << 31) - var2) * 3125) / var1;
										var1 = (((__int64)dig_P9) * (p >> 13) * (p >> 13)) >> 25;
										var2 = (((__int64)dig_P8) * p) >> 19;
										p = ((p + var1 + var2) >> 8) + (((__int64)dig_P7) << 4);
										df_P = (double)p / (double)256;
										//Alex findings
										df_P += 2996;
									}

									{
										//humidity
										int v_x1_u32r, adc_H;
										unsigned int ui_Res;
			
										unsigned char dig_H1, dig_H3;
										char dig_H6;
										short dig_H2, dig_H4, dig_H5;
		
										adc_H = (short)ucRCPat[0xff + 0x07] + ((short)ucRCPat[0xff + 0x06] << 8);

										dig_H1 = (unsigned char)ucRCPat[0xa1];
										dig_H2 = (short)ucRCPat[0xe1] + ((short)ucRCPat[0xe2] << 8);
										dig_H3 = (unsigned char)ucRCPat[0xe3];

										dig_H4 = (short)ucRCPat[0xe5] & 0x0f;
										dig_H4 += (short)ucRCPat[0xe4] << 4;
	
										dig_H5 = (short)(ucRCPat[0xe5] & 0xf0) >> 4;
										dig_H5 += (short)(ucRCPat[0xe6] << 8) >> 4;

										dig_H6 = (char)ucRCPat[0xe7];

										v_x1_u32r = (t_fine_mst - ((int)76800));
										v_x1_u32r = (((((adc_H << 14) - (((int)dig_H4) << 20) - (((int)dig_H5) * v_x1_u32r)) + ((int)16384)) >> 15) * (((((((v_x1_u32r * ((int)dig_H6)) >> 10) * (((v_x1_u32r * ((int)dig_H3)) >> 11) + ((int)32768))) >> 10) + ((int)2097152)) * ((int)dig_H2) + 8192) >> 14));
										v_x1_u32r = (v_x1_u32r - (((((v_x1_u32r >> 15) * (v_x1_u32r >> 15)) >> 7) * ((int)dig_H1)) >> 4));
										v_x1_u32r = (v_x1_u32r < 0 ? 0 : v_x1_u32r); v_x1_u32r = (v_x1_u32r > 419430400 ? 419430400 : v_x1_u32r);
										ui_Res = (unsigned int)(v_x1_u32r >> 12);
										df_H = (double)ui_Res / (double)1024;
									}

									printf("Temp, deg C: %lf; Pres, Pa: %lf; Hum, pH: %lf \n", df_T, df_P, df_H);

									ttTime = time(NULL);
									ctime_s((char*)ucVdata, sizeof(ucVdata), &ttTime);
									for (uiRCCntr = 0; uiRCCntr < sizeof(ucVdata); uiRCCntr++)
									{
										if (CARRRET == ucVdata[uiRCCntr])
										{
											ucVdata[uiRCCntr] = 0;
										}
									}
									/**************************************
									** Storing temperature into log file***
									***************************************/
									if (!fopen_s(&fpFile, "temperatute.log", "a"))
									{
										fprintf(fpFile, "[%s] %lf\n", ucVdata, df_T);
										fclose(fpFile);
									}
									/**************************************
									** Storing pressure into log file***
									***************************************/
									if (!fopen_s(&fpFile, "pressure.log", "a"))
									{
										fprintf(fpFile, "[%s] %lf\n", ucVdata, df_P);
										fclose(fpFile);
									}
									/**************************************
									** Storing humidity into log file***
									***************************************/
									if (!fopen_s(&fpFile, "humidity.log", "a"))
									{
										fprintf(fpFile, "[%s] %lf\n", ucVdata, df_H);
										fclose(fpFile);
									}
									/**************************************
									******* Storing all into CSV file******
									***************************************/
									if (!fopen_s(&fpFile, "meteodata.csv", "a"))
									{
										fprintf(fpFile, "[%s],%lf,%lf,%lf\n", ucVdata, df_T, df_P, df_H);
										fclose(fpFile);
									}
									/*****************************
									***** Sending all to web******
									******************************/
									sprintf_s(cBuf, sizeof(cBuf), "curl.exe --output temporary.tmp http://alxlabs.ca/weather/getwx.php?p=[%s], %lf, %lf, %lf\n", ucVdata, df_T, df_P, df_H);
									for (uiRCCntr = 40; uiRCCntr < sizeof(cBuf); uiRCCntr++)
									{
										if (32 == cBuf[uiRCCntr])
										{
											cBuf[uiRCCntr] = 88;
										}
									}
									system(cBuf);
								}
							}
						}
						else
						{
							uiMatch = 0;
						}

					}
				}
			}
			CloseHandle(hPort);
		}
	}
	else
	{
		_tprintf(_T("Fatal Error: GetModuleHandle failed\n"));
		nRetCode = 1;
	}

	return nRetCode;
}
